<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/MediaPlayer/GStreamerMediaPlayer/include/MediaPlayer/MediaPlayer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_9d34932954f3d83257e5e12e3f421a72.html">MediaPlayer</a></li><li class="navelem"><a class="el" href="dir_e1f7d5df1447213cfb529aad5fa2c859.html">GStreamerMediaPlayer</a></li><li class="navelem"><a class="el" href="dir_d1a5c25c65a86ab490915a47e76c835a.html">include</a></li><li class="navelem"><a class="el" href="dir_9b83a3a02537ea061e11167c986dd2c8.html">MediaPlayer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">MediaPlayer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_media_player_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_MEDIAPLAYER_GSTREAMERMEDIAPLAYER_INCLUDE_MEDIAPLAYER_MEDIAPLAYER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_MEDIAPLAYER_GSTREAMERMEDIAPLAYER_INCLUDE_MEDIAPLAYER_MEDIAPLAYER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;cstdint&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;future&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;queue&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;gst/gst.h&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;gst/app/gstappsrc.h&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;gst/base/gstbasesink.h&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_equalizer_interface_8h.html">AVSCommon/SDKInterfaces/Audio/EqualizerInterface.h</a>&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_h_t_t_p_content_fetcher_interface_factory_interface_8h.html">AVSCommon/SDKInterfaces/HTTPContentFetcherInterfaceFactoryInterface.h</a>&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_speaker_interface_8h.html">AVSCommon/SDKInterfaces/SpeakerInterface.h</a>&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_media_player_interface_8h.html">AVSCommon/Utils/MediaPlayer/MediaPlayerInterface.h</a>&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_media_player_observer_interface_8h.html">AVSCommon/Utils/MediaPlayer/MediaPlayerObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_playlist_parser_interface_8h.html">AVSCommon/Utils/PlaylistParser/PlaylistParserInterface.h</a>&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_url_content_to_attachment_converter_8h.html">PlaylistParser/UrlContentToAttachmentConverter.h</a>&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_offset_manager_8h.html">MediaPlayer/OffsetManager.h</a>&quot;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_pipeline_interface_8h.html">MediaPlayer/PipelineInterface.h</a>&quot;</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_source_interface_8h.html">MediaPlayer/SourceInterface.h</a>&quot;</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">namespace </span>mediaPlayer {</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1media_player.html#a056618af1246218cc1c4524bc3aac256">   48</a></span>&#160;<span class="keyword">typedef</span> std::vector&lt;avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface::TagKeyValueType&gt; <a class="code" href="namespacealexa_client_s_d_k_1_1media_player.html#a056618af1246218cc1c4524bc3aac256">VectorOfTags</a>;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html">   53</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html">MediaPlayer</a></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">avsCommon::utils::RequiresShutdown</a></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html">avsCommon::utils::mediaPlayer::MediaPlayerInterface</a></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html">avsCommon::sdkInterfaces::SpeakerInterface</a></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        , <span class="keyword">private</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html">PipelineInterface</a></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio_1_1_equalizer_interface.html">avsCommon::sdkInterfaces::audio::EqualizerInterface</a></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1playlist_parser_1_1_url_content_to_attachment_converter_1_1_error_observer_interface.html">playlistParser::UrlContentToAttachmentConverter::ErrorObserverInterface</a></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        , <span class="keyword">public</span> std::enable_shared_from_this&lt;MediaPlayer&gt; {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;MediaPlayer&gt; <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a699012eee5cffecd15654d049e670e79">create</a>(</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::HTTPContentFetcherInterfaceFactoryInterface&gt; contentFetcherFactory =</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordtype">bool</span> enableEqualizer = <span class="keyword">false</span>,</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html#a45fb9f447f7a2ed2d9ffb211c089de93">avsCommon::sdkInterfaces::SpeakerInterface::Type</a> type =</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;            <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html#a45fb9f447f7a2ed2d9ffb211c089de93aafb2a925f44a0b297bb16586a46dce7f">avsCommon::sdkInterfaces::SpeakerInterface::Type::AVS_SPEAKER_VOLUME</a>,</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        std::string <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a> = <span class="stringliteral">&quot;&quot;</span>,</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordtype">bool</span> enableLiveMode = <span class="keyword">false</span>);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a9a3084309902d84b2315005fe218ba3f">~MediaPlayer</a>();</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a1c46b09927e8d5a3a606986453fe44c2">setSource</a>(</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentReader&gt; attachmentReader,</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">avsCommon::utils::AudioFormat</a>* format = <span class="keyword">nullptr</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a1c46b09927e8d5a3a606986453fe44c2">setSource</a>(std::shared_ptr&lt;std::istream&gt; stream, <span class="keywordtype">bool</span> repeat) <span class="keyword">override</span>;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a1c46b09927e8d5a3a606986453fe44c2">setSource</a>(</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keyword">const</span> std::string&amp; url,</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        std::chrono::milliseconds offset = std::chrono::milliseconds::zero(),</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keywordtype">bool</span> repeat = <span class="keyword">false</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a6e3f97c24a5ee8cf5ad698de4ff70362">play</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#af8e1300838fcd41cef9a9bf2d18b5e9a">stop</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#aeeb3334b462899a3bab9bb41e9f2f69e">pause</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#afd6e7598a71b9a91409fc683b7886e9b">resume</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    uint64_t <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#afad3bdc0d72ad4e80b6fb9d48c668a3b">getNumBytesBuffered</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    std::chrono::milliseconds <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ae9b262d5eae687beaa30d9dc7e28d4e8">getOffset</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>) <span class="keyword">override</span>;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a271e75fecb39b734cafb9f1260611e79">setObserver</a>(std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface&gt; observer) <span class="keyword">override</span>;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a96a794363f88696df19ca3572e607296">setVolume</a>(int8_t volume) <span class="keyword">override</span>;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a5f05b7f5d73753a63557d90ca98d2901">adjustVolume</a>(int8_t volume) <span class="keyword">override</span>;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a479054c0e1c99d5e420d4cbbc1a99d8e">setMute</a>(<span class="keywordtype">bool</span> mute) <span class="keyword">override</span>;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a60bd8f48814dd1045737c19668d79b70">getSpeakerSettings</a>(<a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface_1_1_speaker_settings.html">avsCommon::sdkInterfaces::SpeakerInterface::SpeakerSettings</a>* settings) <span class="keyword">override</span>;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html#a45fb9f447f7a2ed2d9ffb211c089de93">avsCommon::sdkInterfaces::SpeakerInterface::Type</a> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a0af3c9628a3d6f7b72dc1342f840bdcb">getSpeakerType</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a2511dfe48da19611a02b9e87e939cb7c">setAppSrc</a>(GstAppSrc* appSrc) <span class="keyword">override</span>;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    GstAppSrc* <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ae36f33caf12c633b936a3b5a2f054adb">getAppSrc</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#af4089dee120a37c3c4f7016c647cfe26">setDecoder</a>(GstElement* decoder) <span class="keyword">override</span>;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    GstElement* <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ab6b5f8f2a0cb22299a20de4bfb1d8e11">getDecoder</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    GstElement* <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a349de9f04e24a208f65357d3ce32ef22">getPipeline</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    guint <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a49bda1306d465d81023f9743e1350f62">queueCallback</a>(<span class="keyword">const</span> std::function&lt;gboolean()&gt;* callback) <span class="keyword">override</span>;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    guint <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a4ea8c20e31d8fb4d9c74e009ab9f74a2">attachSource</a>(GSource* source) <span class="keyword">override</span>;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    gboolean <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#aae0be228bf3888f89759296cb4329ecb">removeSource</a>(guint tag) <span class="keyword">override</span>;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#aadab946342a405b7796e2f013aa2f0a8">onError</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a98c1f81565f95a53704af13a3482e55f">doShutdown</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="keyword">struct </span>AudioPipeline {</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        GstAppSrc* appsrc;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        GstElement* decoder;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        GstElement* decodedQueue;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        GstElement* converter;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        GstElement* volume;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        GstElement* resample;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        GstElement* caps;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        GstElement* equalizer;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        GstElement* audioSink;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        GstElement* pipeline;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        AudioPipeline() :</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                appsrc{<span class="keyword">nullptr</span>},</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                decoder{<span class="keyword">nullptr</span>},</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                decodedQueue{<span class="keyword">nullptr</span>},</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                converter{<span class="keyword">nullptr</span>},</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                volume{<span class="keyword">nullptr</span>},</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                audioSink{<span class="keyword">nullptr</span>},</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;                pipeline{<span class="keyword">nullptr</span>} {};</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    };</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html">MediaPlayer</a>(</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::HTTPContentFetcherInterfaceFactoryInterface&gt; contentFetcherFactory,</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        <span class="keywordtype">bool</span> enableEqualizer,</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html#a45fb9f447f7a2ed2d9ffb211c089de93">avsCommon::sdkInterfaces::SpeakerInterface::Type</a> type,</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        std::string <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a>,</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        <span class="keywordtype">bool</span> enableLiveMode);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="keywordtype">void</span> workerLoop();</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keywordtype">bool</span> init();</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keyword">static</span> gboolean onCallback(<span class="keyword">const</span> std::function&lt;gboolean()&gt;* callback);</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    <span class="keywordtype">bool</span> setupPipeline();</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    <span class="keywordtype">void</span> tearDownTransientPipelineElements(<span class="keywordtype">bool</span> notifyStop);</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <span class="keywordtype">void</span> resetPipeline();</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> onPadAdded(GstElement* src, GstPad* pad, gpointer mediaPlayer);</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <span class="keywordtype">void</span> handlePadAdded(std::promise&lt;void&gt;* promise, GstElement* src, GstPad* pad);</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="keyword">static</span> gboolean onBusMessage(GstBus* bus, GstMessage* msg, gpointer mediaPlayer);</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    gboolean handleBusMessage(GstMessage* message);</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    std::unique_ptr&lt;const VectorOfTags&gt; collectTags(GstMessage* message);</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="keywordtype">void</span> sendStreamTagsToObserver(std::unique_ptr&lt;const VectorOfTags&gt; vectorOfTags);</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <span class="keywordtype">void</span> handleSetAttachmentReaderSource(</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentReader&gt; reader,</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        std::promise&lt;SourceId&gt;* promise,</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">avsCommon::utils::AudioFormat</a>* audioFormat = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        <span class="keywordtype">bool</span> repeat = <span class="keyword">false</span>);</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    <span class="keywordtype">void</span> handleSetUrlSource(</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        <span class="keyword">const</span> std::string&amp; url,</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;        std::chrono::milliseconds offset,</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        std::promise&lt;SourceId&gt;* promise,</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        <span class="keywordtype">bool</span> repeat);</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    <span class="keywordtype">void</span> handleSetIStreamSource(std::shared_ptr&lt;std::istream&gt; stream, <span class="keywordtype">bool</span> repeat, std::promise&lt;SourceId&gt;* promise);</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keywordtype">void</span> handleSetVolumeInternal(gdouble gstVolume);</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <span class="keywordtype">void</span> handleSetVolume(std::promise&lt;bool&gt;* promise, int8_t volume);</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;    <span class="keywordtype">void</span> handleAdjustVolume(std::promise&lt;bool&gt;* promise, int8_t delta);</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    <span class="keywordtype">void</span> handleSetMute(std::promise&lt;bool&gt;* promise, <span class="keywordtype">bool</span> mute);</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    <span class="keywordtype">void</span> handleGetSpeakerSettings(</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;        std::promise&lt;bool&gt;* promise,</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface_1_1_speaker_settings.html">avsCommon::sdkInterfaces::SpeakerInterface::SpeakerSettings</a>* settings);</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    <span class="keywordtype">void</span> handlePlay(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>, std::promise&lt;bool&gt;* promise);</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    <span class="keywordtype">void</span> handleStop(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>, std::promise&lt;bool&gt;* promise);</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    <span class="keywordtype">void</span> handlePause(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>, std::promise&lt;bool&gt;* promise);</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;    <span class="keywordtype">void</span> handleResume(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>, std::promise&lt;bool&gt;* promise);</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;    <span class="keywordtype">void</span> handleGetOffset(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>, std::promise&lt;std::chrono::milliseconds&gt;* promise);</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;    <span class="keywordtype">void</span> handleSetObserver(</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;        std::promise&lt;void&gt;* promise,</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;        std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface&gt; observer);</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;    <span class="keywordtype">void</span> sendPlaybackStarted();</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;    <span class="keywordtype">void</span> sendPlaybackFinished();</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;    <span class="keywordtype">void</span> sendPlaybackPaused();</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    <span class="keywordtype">void</span> sendPlaybackResumed();</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;    <span class="keywordtype">void</span> sendPlaybackStopped();</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;    <span class="keywordtype">void</span> sendPlaybackError(</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;        <span class="keyword">const</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player.html#ab6ff57ee3fc3650d3b710fa12d32e25d">alexaClientSDK::avsCommon::utils::mediaPlayer::ErrorType</a>&amp; type,</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;        <span class="keyword">const</span> std::string&amp; error);</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;    <span class="keywordtype">void</span> sendBufferUnderrun();</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;    <span class="keywordtype">void</span> sendBufferRefilled();</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;    <span class="keywordtype">bool</span> queryIsSeekable(<span class="keywordtype">bool</span>* isSeekable);</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;    <span class="keywordtype">bool</span> queryBufferPercent(gint* percent);</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;    <span class="keywordtype">bool</span> seek();</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;</div><div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;    <span class="keywordtype">bool</span> validateSourceAndId(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> <span class="keywordtype">id</span>);</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;</div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;    <span class="keyword">static</span> gboolean onErrorCallback(gpointer pointer);</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;</div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;    std::chrono::milliseconds getCurrentStreamOffset();</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;    <span class="keywordtype">void</span> cleanUpSource();</div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;</div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;    <span class="keywordtype">void</span> setEqualizerBandLevels(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio.html#a9e92dbf094527d2bf8ead4429f0ef9ea">avsCommon::sdkInterfaces::audio::EqualizerBandLevelMap</a> bandLevelMap) <span class="keyword">override</span>;</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;    <span class="keywordtype">int</span> getMinimumBandLevel() <span class="keyword">override</span>;</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;    <span class="keywordtype">int</span> getMaximumBandLevel() <span class="keyword">override</span>;</div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;    <span class="keywordtype">int</span> clampEqualizerLevel(<span class="keywordtype">int</span> level);</div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;</div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;    gdouble m_lastVolume;</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;    <span class="keywordtype">bool</span> m_isMuted;</div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;</div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;    std::shared_ptr&lt;playlistParser::UrlContentToAttachmentConverter&gt; m_urlConverter;</div><div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160;</div><div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1_offset_manager.html">OffsetManager</a> m_offsetManager;</div><div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;</div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::HTTPContentFetcherInterfaceFactoryInterface&gt; m_contentFetcherFactory;</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;</div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;    <span class="keywordtype">bool</span> m_equalizerEnabled;</div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;</div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;    AudioPipeline m_pipeline;</div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html#a45fb9f447f7a2ed2d9ffb211c089de93">avsCommon::sdkInterfaces::SpeakerInterface::Type</a> m_speakerType;</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;</div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;    GMainLoop* m_mainLoop;</div><div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;</div><div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;    <span class="comment">// Main loop thread</span></div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;    std::thread m_mainLoopThread;</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;</div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;    guint m_busWatchId;</div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;</div><div class="line"><a name="l00587"></a><span class="lineno">  587</span>&#160;    GMainContext* m_workerContext;</div><div class="line"><a name="l00588"></a><span class="lineno">  588</span>&#160;</div><div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160;    <span class="keywordtype">bool</span> m_playbackStartedSent;</div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;</div><div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160;    <span class="keywordtype">bool</span> m_playbackFinishedSent;</div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;</div><div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;    <span class="keywordtype">bool</span> m_isPaused;</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;</div><div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;    <span class="keywordtype">bool</span> m_isBufferUnderrun;</div><div class="line"><a name="l00600"></a><span class="lineno">  600</span>&#160;</div><div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160;    std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface&gt; m_playerObserver;</div><div class="line"><a name="l00603"></a><span class="lineno">  603</span>&#160;</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;    std::shared_ptr&lt;SourceInterface&gt; m_source;</div><div class="line"><a name="l00606"></a><span class="lineno">  606</span>&#160;</div><div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">SourceId</a> m_currentId;</div><div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160;</div><div class="line"><a name="l00611"></a><span class="lineno">  611</span>&#160;    <span class="keywordtype">bool</span> m_playPending;</div><div class="line"><a name="l00612"></a><span class="lineno">  612</span>&#160;</div><div class="line"><a name="l00614"></a><span class="lineno">  614</span>&#160;    <span class="keywordtype">bool</span> m_pausePending;</div><div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160;</div><div class="line"><a name="l00617"></a><span class="lineno">  617</span>&#160;    <span class="keywordtype">bool</span> m_resumePending;</div><div class="line"><a name="l00618"></a><span class="lineno">  618</span>&#160;</div><div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;    <span class="keywordtype">bool</span> m_pauseImmediately;</div><div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;</div><div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;    std::chrono::milliseconds m_offsetBeforeTeardown;</div><div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160;</div><div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">bool</span> m_isLiveMode;</div><div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;};</div><div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;</div><div class="line"><a name="l00629"></a><span class="lineno">  629</span>&#160;}  <span class="comment">// namespace mediaPlayer</span></div><div class="line"><a name="l00630"></a><span class="lineno">  630</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00631"></a><span class="lineno">  631</span>&#160;</div><div class="line"><a name="l00632"></a><span class="lineno">  632</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_MEDIAPLAYER_GSTREAMERMEDIAPLAYER_INCLUDE_MEDIAPLAYER_MEDIAPLAYER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_af8e1300838fcd41cef9a9bf2d18b5e9a"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#af8e1300838fcd41cef9a9bf2d18b5e9a">alexaClientSDK::mediaPlayer::MediaPlayer::stop</a></div><div class="ttdeci">bool stop(SourceId id) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:271</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1media_player_html_a056618af1246218cc1c4524bc3aac256"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1media_player.html#a056618af1246218cc1c4524bc3aac256">alexaClientSDK::mediaPlayer::VectorOfTags</a></div><div class="ttdeci">std::vector&lt; avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface::TagKeyValueType &gt; VectorOfTags</div><div class="ttdef"><b>Definition:</b> MediaPlayer.h:48</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a9a3084309902d84b2315005fe218ba3f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a9a3084309902d84b2315005fe218ba3f">alexaClientSDK::mediaPlayer::MediaPlayer::~MediaPlayer</a></div><div class="ttdeci">~MediaPlayer()</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:175</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html">alexaClientSDK::avsCommon::utils::mediaPlayer::MediaPlayerInterface</a></div><div class="ttdef"><b>Definition:</b> MediaPlayerInterface.h:57</div></div>
<div class="ttc" id="_media_player_observer_interface_8h_html"><div class="ttname"><a href="_media_player_observer_interface_8h.html">MediaPlayerObserverInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface_html_a45fb9f447f7a2ed2d9ffb211c089de93aafb2a925f44a0b297bb16586a46dce7f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html#a45fb9f447f7a2ed2d9ffb211c089de93aafb2a925f44a0b297bb16586a46dce7f">alexaClientSDK::avsCommon::sdkInterfaces::SpeakerInterface::Type::AVS_SPEAKER_VOLUME</a></div><div class="ttdoc">Volume type reflecting AVS Speaker API volume. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a98c1f81565f95a53704af13a3482e55f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a98c1f81565f95a53704af13a3482e55f">alexaClientSDK::mediaPlayer::MediaPlayer::doShutdown</a></div><div class="ttdeci">void doShutdown() override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:942</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a60bd8f48814dd1045737c19668d79b70"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a60bd8f48814dd1045737c19668d79b70">alexaClientSDK::mediaPlayer::MediaPlayer::getSpeakerSettings</a></div><div class="ttdeci">bool getSpeakerSettings(avsCommon::sdkInterfaces::SpeakerInterface::SpeakerSettings *settings) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:474</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio_1_1_equalizer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio_1_1_equalizer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::audio::EqualizerInterface</a></div><div class="ttdef"><b>Definition:</b> EqualizerInterface.h:29</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio_html_a9e92dbf094527d2bf8ead4429f0ef9ea"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1audio.html#a9e92dbf094527d2bf8ead4429f0ef9ea">alexaClientSDK::avsCommon::sdkInterfaces::audio::EqualizerBandLevelMap</a></div><div class="ttdeci">std::unordered_map&lt; EqualizerBand, int, utils::functional::EnumClassHash &gt; EqualizerBandLevelMap</div><div class="ttdoc">A collection of bands with their level values. This is an alias for EqualizerBand to band level (int)...</div><div class="ttdef"><b>Definition:</b> EqualizerTypes.h:79</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_ae36f33caf12c633b936a3b5a2f054adb"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ae36f33caf12c633b936a3b5a2f054adb">alexaClientSDK::mediaPlayer::MediaPlayer::getAppSrc</a></div><div class="ttdeci">GstAppSrc * getAppSrc() const override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:548</div></div>
<div class="ttc" id="_speaker_interface_8h_html"><div class="ttname"><a href="_speaker_interface_8h.html">SpeakerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface_html_a45fb9f447f7a2ed2d9ffb211c089de93"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html#a45fb9f447f7a2ed2d9ffb211c089de93">alexaClientSDK::avsCommon::sdkInterfaces::SpeakerInterface::Type</a></div><div class="ttdeci">Type</div><div class="ttdef"><b>Definition:</b> SpeakerInterface.h:36</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface_html_a97b83ae4aaeabff7bb8a796a8a018623"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">alexaClientSDK::avsCommon::utils::mediaPlayer::MediaPlayerInterface::SourceId</a></div><div class="ttdeci">uint64_t SourceId</div><div class="ttdoc">A type that identifies which source is currently being operated on. </div><div class="ttdef"><b>Definition:</b> MediaPlayerInterface.h:60</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a96a794363f88696df19ca3572e607296"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a96a794363f88696df19ca3572e607296">alexaClientSDK::mediaPlayer::MediaPlayer::setVolume</a></div><div class="ttdeci">bool setVolume(int8_t volume) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:342</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></div><div class="ttdef"><b>Definition:</b> RequiresShutdown.h:32</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a2511dfe48da19611a02b9e87e939cb7c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a2511dfe48da19611a02b9e87e939cb7c">alexaClientSDK::mediaPlayer::MediaPlayer::setAppSrc</a></div><div class="ttdeci">void setAppSrc(GstAppSrc *appSrc) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:544</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html_a745cd4dc404db52f7d0afbf838454fac"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">alexaClientSDK::avsCommon::utils::RequiresShutdown::name</a></div><div class="ttdeci">const std::string &amp; name() const</div><div class="ttdef"><b>Definition:</b> RequiresShutdown.cpp:131</div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">alexaClientSDK::avsCommon::utils::AudioFormat</a></div><div class="ttdef"><b>Definition:</b> AudioFormat.h:31</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::SpeakerInterface</a></div><div class="ttdef"><b>Definition:</b> SpeakerInterface.h:31</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_offset_manager_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_offset_manager.html">alexaClientSDK::mediaPlayer::OffsetManager</a></div><div class="ttdef"><b>Definition:</b> OffsetManager.h:27</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a0af3c9628a3d6f7b72dc1342f840bdcb"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a0af3c9628a3d6f7b72dc1342f840bdcb">alexaClientSDK::mediaPlayer::MediaPlayer::getSpeakerType</a></div><div class="ttdeci">avsCommon::sdkInterfaces::SpeakerInterface::Type getSpeakerType() override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:539</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a4ea8c20e31d8fb4d9c74e009ab9f74a2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a4ea8c20e31d8fb4d9c74e009ab9f74a2">alexaClientSDK::mediaPlayer::MediaPlayer::attachSource</a></div><div class="ttdeci">guint attachSource(GSource *source) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:914</div></div>
<div class="ttc" id="_source_interface_8h_html"><div class="ttname"><a href="_source_interface_8h.html">SourceInterface.h</a></div></div>
<div class="ttc" id="_equalizer_interface_8h_html"><div class="ttname"><a href="_equalizer_interface_8h.html">EqualizerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_ab6b5f8f2a0cb22299a20de4bfb1d8e11"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ab6b5f8f2a0cb22299a20de4bfb1d8e11">alexaClientSDK::mediaPlayer::MediaPlayer::getDecoder</a></div><div class="ttdeci">GstElement * getDecoder() const override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:556</div></div>
<div class="ttc" id="_playlist_parser_interface_8h_html"><div class="ttname"><a href="_playlist_parser_interface_8h.html">PlaylistParserInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a5f05b7f5d73753a63557d90ca98d2901"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a5f05b7f5d73753a63557d90ca98d2901">alexaClientSDK::mediaPlayer::MediaPlayer::adjustVolume</a></div><div class="ttdeci">bool adjustVolume(int8_t volume) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:394</div></div>
<div class="ttc" id="_media_player_interface_8h_html"><div class="ttname"><a href="_media_player_interface_8h.html">MediaPlayerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_aeeb3334b462899a3bab9bb41e9f2f69e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#aeeb3334b462899a3bab9bb41e9f2f69e">alexaClientSDK::mediaPlayer::MediaPlayer::pause</a></div><div class="ttdeci">bool pause(SourceId id) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:285</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a49bda1306d465d81023f9743e1350f62"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a49bda1306d465d81023f9743e1350f62">alexaClientSDK::mediaPlayer::MediaPlayer::queueCallback</a></div><div class="ttdeci">guint queueCallback(const std::function&lt; gboolean()&gt; *callback) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:902</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_afd6e7598a71b9a91409fc683b7886e9b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#afd6e7598a71b9a91409fc683b7886e9b">alexaClientSDK::mediaPlayer::MediaPlayer::resume</a></div><div class="ttdeci">bool resume(SourceId id) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:299</div></div>
<div class="ttc" id="_offset_manager_8h_html"><div class="ttname"><a href="_offset_manager_8h.html">OffsetManager.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a1c46b09927e8d5a3a606986453fe44c2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a1c46b09927e8d5a3a606986453fe44c2">alexaClientSDK::mediaPlayer::MediaPlayer::setSource</a></div><div class="ttdeci">SourceId setSource(std::shared_ptr&lt; avsCommon::avs::attachment::AttachmentReader &gt; attachmentReader, const avsCommon::utils::AudioFormat *format=nullptr) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:191</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a479054c0e1c99d5e420d4cbbc1a99d8e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a479054c0e1c99d5e420d4cbbc1a99d8e">alexaClientSDK::mediaPlayer::MediaPlayer::setMute</a></div><div class="ttdeci">bool setMute(bool mute) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:446</div></div>
<div class="ttc" id="_h_t_t_p_content_fetcher_interface_factory_interface_8h_html"><div class="ttname"><a href="_h_t_t_p_content_fetcher_interface_factory_interface_8h.html">HTTPContentFetcherInterfaceFactoryInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a699012eee5cffecd15654d049e670e79"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a699012eee5cffecd15654d049e670e79">alexaClientSDK::mediaPlayer::MediaPlayer::create</a></div><div class="ttdeci">static std::shared_ptr&lt; MediaPlayer &gt; create(std::shared_ptr&lt; avsCommon::sdkInterfaces::HTTPContentFetcherInterfaceFactoryInterface &gt; contentFetcherFactory=nullptr, bool enableEqualizer=false, avsCommon::sdkInterfaces::SpeakerInterface::Type type=avsCommon::sdkInterfaces::SpeakerInterface::Type::AVS_SPEAKER_VOLUME, std::string name=&quot;&quot;, bool enableLiveMode=false)</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:159</div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface_1_1_speaker_settings_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_speaker_interface_1_1_speaker_settings.html">alexaClientSDK::avsCommon::sdkInterfaces::SpeakerInterface::SpeakerSettings</a></div><div class="ttdef"><b>Definition:</b> SpeakerInterface.h:50</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html">alexaClientSDK::mediaPlayer::MediaPlayer</a></div><div class="ttdef"><b>Definition:</b> MediaPlayer.h:53</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1playlist_parser_1_1_url_content_to_attachment_converter_1_1_error_observer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1playlist_parser_1_1_url_content_to_attachment_converter_1_1_error_observer_interface.html">alexaClientSDK::playlistParser::UrlContentToAttachmentConverter::ErrorObserverInterface</a></div><div class="ttdoc">Class to observe errors that arise from converting a URL to to an Attachment. </div><div class="ttdef"><b>Definition:</b> UrlContentToAttachmentConverter.h:43</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="_pipeline_interface_8h_html"><div class="ttname"><a href="_pipeline_interface_8h.html">PipelineInterface.h</a></div></div>
<div class="ttc" id="_url_content_to_attachment_converter_8h_html"><div class="ttname"><a href="_url_content_to_attachment_converter_8h.html">UrlContentToAttachmentConverter.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_af4089dee120a37c3c4f7016c647cfe26"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#af4089dee120a37c3c4f7016c647cfe26">alexaClientSDK::mediaPlayer::MediaPlayer::setDecoder</a></div><div class="ttdeci">void setDecoder(GstElement *decoder) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:552</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_aadab946342a405b7796e2f013aa2f0a8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#aadab946342a405b7796e2f013aa2f0a8">alexaClientSDK::mediaPlayer::MediaPlayer::onError</a></div><div class="ttdeci">void onError() override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:929</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a6e3f97c24a5ee8cf5ad698de4ff70362"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a6e3f97c24a5ee8cf5ad698de4ff70362">alexaClientSDK::mediaPlayer::MediaPlayer::play</a></div><div class="ttdeci">bool play(SourceId id) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:249</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_html_ab6ff57ee3fc3650d3b710fa12d32e25d"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player.html#ab6ff57ee3fc3650d3b710fa12d32e25d">alexaClientSDK::avsCommon::utils::mediaPlayer::ErrorType</a></div><div class="ttdeci">ErrorType</div><div class="ttdoc">Identifies the specific type of error in a PlaybackFailed event. </div><div class="ttdef"><b>Definition:</b> ErrorTypes.h:27</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_ae9b262d5eae687beaa30d9dc7e28d4e8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#ae9b262d5eae687beaa30d9dc7e28d4e8">alexaClientSDK::mediaPlayer::MediaPlayer::getOffset</a></div><div class="ttdeci">std::chrono::milliseconds getOffset(SourceId id) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:313</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_pipeline_interface.html">alexaClientSDK::mediaPlayer::PipelineInterface</a></div><div class="ttdef"><b>Definition:</b> PipelineInterface.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a349de9f04e24a208f65357d3ce32ef22"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a349de9f04e24a208f65357d3ce32ef22">alexaClientSDK::mediaPlayer::MediaPlayer::getPipeline</a></div><div class="ttdeci">GstElement * getPipeline() const override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:560</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_a271e75fecb39b734cafb9f1260611e79"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a271e75fecb39b734cafb9f1260611e79">alexaClientSDK::mediaPlayer::MediaPlayer::setObserver</a></div><div class="ttdeci">void setObserver(std::shared_ptr&lt; avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface &gt; observer) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:328</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_aae0be228bf3888f89759296cb4329ecb"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#aae0be228bf3888f89759296cb4329ecb">alexaClientSDK::mediaPlayer::MediaPlayer::removeSource</a></div><div class="ttdeci">gboolean removeSource(guint tag) override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:921</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1_media_player_html_afad3bdc0d72ad4e80b6fb9d48c668a3b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#afad3bdc0d72ad4e80b6fb9d48c668a3b">alexaClientSDK::mediaPlayer::MediaPlayer::getNumBytesBuffered</a></div><div class="ttdeci">uint64_t getNumBytesBuffered() override</div><div class="ttdef"><b>Definition:</b> MediaPlayer.cpp:235</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
